# -*- coding: utf-8 -*-

'''
	Exodus Add-on
	Copyright (C) 2016 Exodus

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
'''


import urlparse,sys

params = dict(urlparse.parse_qsl(sys.argv[2].replace('?','')))

action = params.get('action')

name = params.get('name')

title = params.get('title')

year = params.get('year')

imdb = params.get('imdb')

tvdb = params.get('tvdb')

season = params.get('season')

episode = params.get('episode')

tvshowtitle = params.get('tvshowtitle')

premiered = params.get('premiered')

url = params.get('url')

image = params.get('image')

meta = params.get('meta')

select = params.get('select')

query = params.get('query')

source = params.get('source')

content = params.get('content')


if action == None:
	from resources.lib.indexers import navigator
	navigator.navigator().root()

elif action == 'movieNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().movies()

elif action == 'movieliteNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().movies(lite=True)

elif action == 'mymovieNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().mymovies()

elif action == 'mymovieliteNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().mymovies(lite=True)

elif action == 'tvNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().tvshows()

elif action == 'tvliteNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().tvshows(lite=True)

elif action == 'mytvNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().mytvshows()

elif action == 'mytvliteNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().mytvshows(lite=True)

elif action == 'downloadNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().downloads()

elif action == 'toolNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().tools()

elif action == 'searchNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().search()

elif action == 'viewsNavigator':
	from resources.lib.indexers import navigator
	navigator.navigator().views()

elif action == 'clearCache':
	from resources.lib.indexers import navigator
	navigator.navigator().clearCache()

elif action == 'infoCheck':
	from resources.lib.indexers import navigator
	navigator.navigator().infoCheck('')

elif action == 'movies':
	from resources.lib.indexers import movies
	movies.movies().get(url)

elif action == 'moviePage':
	from resources.lib.indexers import movies
	movies.movies().get(url)

elif action == 'movieWidget':
	from resources.lib.indexers import movies
	movies.movies().widget()

elif action == 'movieSearch':
	from resources.lib.indexers import movies
	movies.movies().search()

elif action == 'moviePerson':
	from resources.lib.indexers import movies
	movies.movies().person()

elif action == 'movieGenres':
	from resources.lib.indexers import movies
	movies.movies().genres()

elif action == 'movieLanguages':
	from resources.lib.indexers import movies
	movies.movies().languages()

elif action == 'movieCertificates':
	from resources.lib.indexers import movies
	movies.movies().certifications()

elif action == 'movieYears':
	from resources.lib.indexers import movies
	movies.movies().years()

elif action == 'moviePersons':
	from resources.lib.indexers import movies
	movies.movies().persons(url)

elif action == 'movieUserlists':
	from resources.lib.indexers import movies
	movies.movies().userlists()

elif action == 'channels':
	from resources.lib.indexers import channels
	channels.channels().get(name)

elif action == 'tvshows':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().get(url)

elif action == 'tvshowPage':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().get(url)

elif action == 'tvSearch':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().search()

elif action == 'tvPerson':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().person()

elif action == 'tvGenres':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().genres()

elif action == 'tvNetworks':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().networks()

elif action == 'tvCertificates':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().certifications()

elif action == 'tvPersons':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().persons(url)

elif action == 'tvUserlists':
	from resources.lib.indexers import tvshows
	tvshows.tvshows().userlists()

elif action == 'seasons':
	from resources.lib.indexers import episodes
	episodes.seasons().get(tvshowtitle, year, imdb, tvdb)

elif action == 'episodes':
	from resources.lib.indexers import episodes
	episodes.episodes().get(tvshowtitle, year, imdb, tvdb, season, episode)

elif action == 'calendar':
	from resources.lib.indexers import episodes
	episodes.episodes().calendar(url)

elif action == 'tvWidget':
	from resources.lib.indexers import episodes
	episodes.episodes().widget()

elif action == 'calendars':
	from resources.lib.indexers import episodes
	episodes.episodes().calendars()

elif action == 'episodeUserlists':
	from resources.lib.indexers import episodes
	episodes.episodes().userlists()

elif action == 'refresh':
	from resources.lib.modules import control
	control.refresh()

elif action == 'queueItem':
	from resources.lib.modules import control
	control.queueItem()

elif action == 'openSettings':
	from resources.lib.modules import control
	control.openSettings(query)

elif action == 'artwork':
	from resources.lib.modules import control
	control.artwork()

elif action == 'addView':
	from resources.lib.modules import views
	views.addView(content)

elif action == 'moviePlaycount':
	from resources.lib.modules import playcount
	playcount.movies(imdb, query)

elif action == 'episodePlaycount':
	from resources.lib.modules import playcount
	playcount.episodes(imdb, tvdb, season, episode, query)

elif action == 'tvPlaycount':
	from resources.lib.modules import playcount
	playcount.tvshows(name, imdb, tvdb, season, query)

elif action == 'trailer':
	from resources.lib.modules import trailer
	trailer.trailer().play(name, url)

elif action == 'traktManager':
	from resources.lib.modules import trakt
	trakt.manager(name, imdb, tvdb, content)

elif action == 'authTrakt':
	from resources.lib.modules import trakt
	trakt.authTrakt()

elif action == 'rdAuthorize':
	from resources.lib.modules import debrid
	debrid.rdAuthorize()

elif action == 'download':
	import json
	from resources.lib.modules import sources
	from resources.lib.modules import downloader
	try: downloader.download(name, image, sources.sources().sourcesResolve(json.loads(source)[0], True))
	except: pass

elif action == 'play':
	from resources.lib.modules import sources
	sources.sources().play(title, year, imdb, tvdb, season, episode, tvshowtitle, premiered, meta, select)

elif action == 'addItem':
	from resources.lib.modules import sources
	sources.sources().addItem(title)

elif action == 'playItem':
	from resources.lib.modules import sources
	sources.sources().playItem(title, source)

elif action == 'alterSources':
	from resources.lib.modules import sources
	sources.sources().alterSources(url, meta)

elif action == 'clearSources':
	from resources.lib.modules import sources
	sources.sources().clearSources()

#Apollo
elif action == 'channelSearch': 
    from resources.lib.indexers import channels
    channels.channels().search(query)
elif action == 'apollo':
    from resources.lib.modules import apollo
    apollo.apollo().run(title, year, season, episode, imdb, tvdb, url, meta)
elif action == 'loginApollo':
    from resources.lib.modules import apollo
    apollo.apollo().login()
elif action == 'logoutApollo':
    from resources.lib.modules import apollo
    apollo.apollo().logout()
elif action == 'apollotvguide':
    from resources.lib.modules import apollo
    apollo.apollo().tvguide()
elif action == 'cleanApollo':
    from resources.lib.modules import apollo
    apollo.apollo().cleanCache()